/// @file
////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Copyright (C) 2019/20      Christian Lessig, Otto-von-Guericke Universitaet Magdeburg
///
////////////////////////////////////////////////////////////////////////////////////////////////////
///
///  module     : Assignment 2
///
///  author     : lessig@isg.cs.ovgu.de
///
///  project    : GPU Programming
///
///  description:
///
////////////////////////////////////////////////////////////////////////////////////////////////////

class Barrier{

public:

  // constructor, default
  Barrier( const unsigned int& n_threads);

  // destructor
  ~Barrier();

public:

  // constructor, copy
  Barrier( const Barrier&) = delete;

  // assignment operator
  Barrier& operator=(const Barrier&) = delete;

  // move constructor
  Barrier( Barrier&&) = delete;

  // move-assign
  Barrier& operator=(Barrier&& );

public:

  // TODO: interface

private:

  // TODO: data members

};
